#  circ2.py
#
from simulator import Text, Swt, Nand, Inv, Wire, gameLoop

tt1 = Text ((150, 50), "2. Making an OR Gate")
ts1 = Text (( 30,115), "S1")
ts2 = Text (( 30,190), "S2")
ti1 = Text (( 95,133), "I1")
ti2 = Text (( 95,173), "I2")
tn1 = Text ((200,150), "N1")
tw5 = Text ((265,140), "w4")

s1 = Swt('s1', ( 30,130), 10, init=1)  # feeds w1  
s2 = Swt('s2', ( 30,170), 10, init=1)  # feeds w2  

i1 = Inv('i1', (100,130), 15)          # feeds w3
i2 = Inv('i2', (100,170), 15)          # feeds w4

n1 = Nand('n1',(200,150), 30)          # feeds w5

w1 = Wire('w1',(( 20,130), (100,130)), s1, [(i1,0)]) # connects s1 to i1 pin 0
w2 = Wire('w2',((100,130), (170,130)), i1, [(n1,0)]) # connects i1 to n1 pin 0
w3 = Wire('w3',(( 20,170), (100,170)), s2, [(i2,0)]) # connects s2 to i2 pin 0
w4 = Wire('w4',((100,170), (170,170)), i2, [(n1,1)]) # connects i2 to n1 pin 1
w5 = Wire('w5',((230,150), (270,150)), n1, [])       # displays n1 output

def main() :
    gates = (w1,w2,w3,w4,w5,n1,i1,i2,s1,s2,tt1,ts1,ts2,ti1,ti2,tn1,tw5)
    gameLoop(gates)

if __name__ == "__main__" : main()

