#  circ4.py
#
from simulator import Text, Swt, Nand, Inv, Wire, gameLoop

tt1 = Text ((150, 50), "4. Simple Latch")
tq1 = Text ((230,100), "Q1")
tq2 = Text ((230,200), "Q2")
tn1 = Text ((150,100), "N1")
tn2 = Text ((150,200), "N2")
ts1 = Text (( 50, 65), "S1") 
ts2 = Text (( 50,250), "S2") 
s1 = Swt   ('s1', ( 50, 80), 10, init=1)  # feeds N1.0
s2 = Swt   ('s2', ( 50,220), 10, init=1)  # feeds N2.1
n1 = Nand  ('n1', (150,100), 30)          # feeds w3
n2 = Nand  ('n2', (150,200), 30)          # feeds w4

w1 = Wire('w1', (( 50, 80), (120, 80)), s1, [(n1,0)]) # connects s1 to n1.0
w2 = Wire('w2', (( 50,220), (120,220)), s2, [(n2,1)]) # connects s2 to n2.1

w3 = Wire('w3', ((190,100), (210,100),    # horz to right
                       (210,140),    # down
                       (100,160),    # diagonal
                       (100,180),    # down again
                       (120,180)),   # right into n2.0
            n1, [(n2,0)])            # connects n1 to n2.0

w4 = Wire('w4', ((190,200), (210,200),    # horz to right
                       (210,160),    # up  
                       (100,140),    # diagonal
                       (100,120),    # up   again
                       (120,120)),   # right into n1.1
            n2, [(n1,1)])            # connects n2 to n1.1

def main() :
    gates = (w1,w2,w3,w4,n1,n2,s1,s2,tn1,tn2,tq1,tq2,ts1,ts2,tt1)
    gameLoop(gates)

if __name__ == "__main__" : main()
