#  circ1.py
#
from simulator import Text, Swt, Nand, Inv, Wire, gameLoop
#           center         Text to display
tt1 = Text ((150, 50), "1. Simple AND Gate")
ts1 = Text (( 50,115), "S1")
ts2 = Text (( 50,190), "S2")
tn1 = Text ((150,150), "N1")
ti1 = Text ((225,150), "I1")
tw1 = Text ((100,120), "w1")
tw2 = Text ((100,180), "w2")
tw4 = Text ((270,140), "w4")

#           name    center  scale 
s1 = Swt   ('s1', ( 50,130), 10, init=1)           # feeds w1
s2 = Swt   ('s2', ( 50,170), 10, init=0)           # feeds w2
n1 = Nand  ('n1', (150,150), 30)                   # feeds w3
i1 = Inv   ('i1', (230,150), 20)                   # feeds w4

#         name   wire points         fed-by  dest(s)
w1 = Wire('w1', (( 50,130), (120,130)), s1, [(n1,0)]) # s1 to n1 pin 0
w2 = Wire('w2', (( 50,170), (120,170)), s2, [(n1,1)]) # s2 to n1 pin 1
w3 = Wire('w3', ((190,150), (210,150)), n1, [(i1,0)]) # n1 to i1 
w4 = Wire('w4', ((240,150), (290,150)), i1, [])       # displays i1 output

def main() :
                         # in drawing order
    gates = (w1,w2,w3,w4,n1,i1,s1,s2,tt1,ts1,ts2,tn1,ti1,tw1,tw2,tw4)
    gameLoop(gates,[s1,s2])

if __name__ == "__main__" : main()
