#  circ3.py  -  XOR Gate
#
from simulator import Text, Swt, Nand, Inv, Wire, gameLoop

tt1 = Text ((150, 50), "3. XOR Gate Construction")
ts1 = Text (( 30, 95), "S1")
ts2 = Text (( 30,210), "S2")
tn1 = Text (( 80,150), "N1")
tn2 = Text ((150,120), "N2")
tn3 = Text ((150,180), "N3")
tn4 = Text ((220,150), "N4")
tw1 = Text (( 80,105), "w1")
tw2 = Text (( 80,200), "w2")
tw6 = Text ((270,140), "w6")


s1 = Swt ('s1',( 30,110),  7, init=0)  # feeds w1  
s2 = Swt ('s2',( 30,190),  7, init=0)  # feeds w2  

n1 = Nand('n1',( 80,150), 20)          # feeds w3
n2 = Nand('n2',(150,120), 20)          # feeds w4
n3 = Nand('n2',(150,180), 20)          # feeds w5
n4 = Nand('n4',(220,150), 20)          # feeds w6

w1p = (( 30,110),(150,110), None, (50,110),(50,140),(70,140))
w2p = (( 30,190),(150,190), None, (50,190),(50,160),(70,160))
w3p = ((100,150),(120,150),(120,130),(130,130), None,
                 (120,150),(120,170),(130,170))
w4p = ((170,120),(190,120),(190,140),(200,140))
w5p = ((170,180),(190,180),(190,160),(200,160))
w6p = ((240,150),(270,150))

w1 = Wire('w1', w1p, s1, [(n1,0),(n2,0)]) # s1 to n1.0 and n2.0 
w2 = Wire('w2', w2p, s2, [(n1,1),(n3,1)]) # s2 to n1.1 and n3.1 
w3 = Wire('w3', w3p, n1, [(n2,1),(n3,0)]) # n1 to n2.1 and n3.0 
w4 = Wire('w4', w4p, n2, [(n4,0)])        # n2 to n4.0
w5 = Wire('w5', w5p, n3, [(n4,1)])        # n3 to n4.1
w6 = Wire('w6', w6p, n4, [])              # n4 display

def main() :
    gates = (w1,w2,w3,w4,w5,w6,n1,n2,n3,n4,
             s1,s2,tt1,ts1,ts2,tn1,tn2,tn3,tn4,tw1,tw2,tw6)
    gameLoop(gates)

if __name__ == "__main__" : main()

